class TelegramBotSubscriber
  def self.subscribe
    ActiveSupport::Notifications.subscribe(/\A(?:session|speaker)\.updated/) do |*args|
      event = ActiveSupport::Notifications::Event.new(*args)
      new.handle_event(event)  # Call the instance method
    end
  end

  def handle_event(event)
    # 1. Extract Relevant Information
    model_name = event.name.split(".").last  # Get "session" or "speaker"
    record = event.payload[:record]
    changes = event.payload[:changes]

    # 2. Format Message for Telegram
    message = format_telegram_message(model_name, record, changes)

    # 3. Send Message via Telegram Bot API
    # (Replace with your actual Telegram bot API integration)
    # TelegramBotAPI.sendMessage(chat_id: YOUR_CHAT_ID, text: message)
    Rails.logger.info("event: #{message}")
  end

  private

  def format_telegram_message(model_name, record, changes)
    # Customize this to your desired message format
    "**#{model_name.capitalize} Updated:**\n\n" +
      changes.map { |attr, (from, to)| "- #{attr}: #{from} -> #{to}" }.join("\n")
  end
end
